var _jsxFileName = "/home/jrebecchi/dev/React-Web-Media-Player/src/components/MenuBar/MenuBar.js";

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { connect } from 'react-redux';
import './MenuBar.css';
import PlayButton from './PlayButton';
import NextButton from './NextButton';
import PreviousButton from './PreviousButton';
import Timer from './Timer';
import FullscreenButton from './FullscreenButton';
import VolumeControl from './VolumeControl';
import ProgressBar from "./ProgressBar";
import LogoButton from "./LogoButton";
import Button from "./Button";

var MenuBar = /*#__PURE__*/function (_Component) {
  _inheritsLoose(MenuBar, _Component);

  function MenuBar() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      e.stopPropagation();
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      var volumeControl, previousButton, nextButton, logo, fullscreenButton;
      var buttons = [];
      if (_this.props.hasVideo || _this.props.hasAudio) volumeControl = /*#__PURE__*/React.createElement(VolumeControl, {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 24,
          columnNumber: 29
        }
      });else {
        previousButton = /*#__PURE__*/React.createElement(PreviousButton, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 26,
            columnNumber: 30
          }
        });
        nextButton = /*#__PURE__*/React.createElement(NextButton, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 27,
            columnNumber: 26
          }
        });
      }

      if (_this.props.logo) {
        logo = /*#__PURE__*/React.createElement(LogoButton, {
          img: _this.props.logo.img,
          href: _this.props.logo.href,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 30,
            columnNumber: 20
          }
        });
      }

      if (_this.props.buttons) {
        for (var i = 0; i < _this.props.buttons.length; ++i) {
          buttons.push( /*#__PURE__*/React.createElement(Button, {
            img: _this.props.buttons[i].img,
            key: i,
            href: _this.props.buttons[i].href,
            style: _this.props.buttons[i].style,
            callback: _this.props.buttons[i].callback,
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 34,
              columnNumber: 30
            }
          }));
        }
      }

      if (_this.props.allowFullFrame) {
        fullscreenButton = /*#__PURE__*/React.createElement(FullscreenButton, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 38,
            columnNumber: 32
          }
        });
      }

      return /*#__PURE__*/React.createElement("div", {
        className: "wmp-menu-bar-container",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 41,
          columnNumber: 13
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "wmp-bottom-shading",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 42,
          columnNumber: 17
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "wmp-menu-bar-offset-left",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 43,
          columnNumber: 17
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "wmp-menu-bar-offset-right",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 44,
          columnNumber: 17
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "wmp-menu-bar",
        onClick: _this.handleClick,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 45,
          columnNumber: 17
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "wmp-tool-constainer",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 46,
          columnNumber: 21
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "wmp-tool-constainer-left",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 47,
          columnNumber: 25
        }
      }, /*#__PURE__*/React.createElement(PlayButton, {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 48,
          columnNumber: 29
        }
      }), volumeControl, previousButton, nextButton, /*#__PURE__*/React.createElement(Timer, {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 52,
          columnNumber: 29
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: "wmp-tool-constainer-right",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 54,
          columnNumber: 25
        }
      }, buttons, logo, fullscreenButton))), /*#__PURE__*/React.createElement(ProgressBar, {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 61,
          columnNumber: 17
        }
      }));
    });

    return _this;
  }

  return MenuBar;
}(Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    hasVideo: state.hasVideo,
    hasAudio: state.hasAudio,
    hasSlideshow: state.hasSlideshow,
    logo: state.logo,
    buttons: state.buttons,
    allowFullFrame: state.allowFullFrame
  };
};

export default connect(mapStateToProps)(MenuBar);