"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

require("./MenuBar.css");

var _PlayButton = _interopRequireDefault(require("./PlayButton"));

var _NextButton = _interopRequireDefault(require("./NextButton"));

var _PreviousButton = _interopRequireDefault(require("./PreviousButton"));

var _Timer = _interopRequireDefault(require("./Timer"));

var _FullscreenButton = _interopRequireDefault(require("./FullscreenButton"));

var _VolumeControl = _interopRequireDefault(require("./VolumeControl"));

var _ProgressBar = _interopRequireDefault(require("./ProgressBar"));

var _LogoButton = _interopRequireDefault(require("./LogoButton"));

var _Button = _interopRequireDefault(require("./Button"));

var _jsxFileName = "/home/jrebecchi/dev/React-Web-Media-Player/src/components/MenuBar/MenuBar.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MenuBar = /*#__PURE__*/function (_Component) {
  _inheritsLoose(MenuBar, _Component);

  function MenuBar() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      e.stopPropagation();
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      var volumeControl, previousButton, nextButton, logo, fullscreenButton;
      var buttons = [];
      if (_this.props.hasVideo || _this.props.hasAudio) volumeControl = /*#__PURE__*/_react["default"].createElement(_VolumeControl["default"], {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 24,
          columnNumber: 29
        }
      });else {
        previousButton = /*#__PURE__*/_react["default"].createElement(_PreviousButton["default"], {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 26,
            columnNumber: 30
          }
        });
        nextButton = /*#__PURE__*/_react["default"].createElement(_NextButton["default"], {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 27,
            columnNumber: 26
          }
        });
      }

      if (_this.props.logo) {
        logo = /*#__PURE__*/_react["default"].createElement(_LogoButton["default"], {
          img: _this.props.logo.img,
          href: _this.props.logo.href,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 30,
            columnNumber: 20
          }
        });
      }

      if (_this.props.buttons) {
        for (var i = 0; i < _this.props.buttons.length; ++i) {
          buttons.push( /*#__PURE__*/_react["default"].createElement(_Button["default"], {
            img: _this.props.buttons[i].img,
            key: i,
            href: _this.props.buttons[i].href,
            style: _this.props.buttons[i].style,
            callback: _this.props.buttons[i].callback,
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 34,
              columnNumber: 30
            }
          }));
        }
      }

      if (_this.props.allowFullFrame) {
        fullscreenButton = /*#__PURE__*/_react["default"].createElement(_FullscreenButton["default"], {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 38,
            columnNumber: 32
          }
        });
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-menu-bar-container",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 41,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-bottom-shading",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 42,
          columnNumber: 17
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-menu-bar-offset-left",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 43,
          columnNumber: 17
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-menu-bar-offset-right",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 44,
          columnNumber: 17
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-menu-bar",
        onClick: _this.handleClick,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 45,
          columnNumber: 17
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-tool-constainer",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 46,
          columnNumber: 21
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-tool-constainer-left",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 47,
          columnNumber: 25
        }
      }, /*#__PURE__*/_react["default"].createElement(_PlayButton["default"], {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 48,
          columnNumber: 29
        }
      }), volumeControl, previousButton, nextButton, /*#__PURE__*/_react["default"].createElement(_Timer["default"], {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 52,
          columnNumber: 29
        }
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-tool-constainer-right",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 54,
          columnNumber: 25
        }
      }, buttons, logo, fullscreenButton))), /*#__PURE__*/_react["default"].createElement(_ProgressBar["default"], {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 61,
          columnNumber: 17
        }
      }));
    });

    return _this;
  }

  return MenuBar;
}(_react.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    hasVideo: state.hasVideo,
    hasAudio: state.hasAudio,
    hasSlideshow: state.hasSlideshow,
    logo: state.logo,
    buttons: state.buttons,
    allowFullFrame: state.allowFullFrame
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps)(MenuBar);

exports["default"] = _default;
module.exports = exports.default;