"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

require("./Button.css");

var _jsxFileName = "/home/jrebecchi/dev/React-Web-Media-Player/src/components/MenuBar/PlayButton.js";

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var playLogo = /*#__PURE__*/_react["default"].createElement("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "30",
  height: "30",
  viewBox: "0 0 24 24",
  className: "play-logo",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 6,
    columnNumber: 5
  }
}, /*#__PURE__*/_react["default"].createElement("path", {
  className: "wmp-tool-button-logo",
  fill: "#e4e5e8",
  d: "M8 5v14l11-7z",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 7,
    columnNumber: 9
  }
}), /*#__PURE__*/_react["default"].createElement("path", {
  d: "M0 0h24v24H0z",
  fill: "none",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 8,
    columnNumber: 9
  }
}));

var pauseLogo = /*#__PURE__*/_react["default"].createElement("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "29",
  height: "29",
  viewBox: "0 0 24 24",
  className: "pause-logo",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 12,
    columnNumber: 5
  }
}, /*#__PURE__*/_react["default"].createElement("path", {
  className: "wmp-tool-button-logo",
  fill: "#e4e5e8",
  d: "M6 19h4V5H6v14zm8-14v14h4V5h-4z",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 13,
    columnNumber: 9
  }
}), /*#__PURE__*/_react["default"].createElement("path", {
  d: "M0 0h24v24H0z",
  fill: "none",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 14,
    columnNumber: 9
  }
}));

var replayLogo = /*#__PURE__*/_react["default"].createElement("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  width: "27",
  height: "27",
  viewBox: "0 0 24 24",
  className: "replay-logo",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 18,
    columnNumber: 5
  }
}, /*#__PURE__*/_react["default"].createElement("path", {
  d: "M0 0h24v24H0z",
  fill: "none",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 19,
    columnNumber: 9
  }
}), /*#__PURE__*/_react["default"].createElement("path", {
  className: "wmp-tool-button-logo",
  fill: "#e4e5e8",
  d: "M12 5V1L7 6l5 5V7c3.31 0 6 2.69 6 6s-2.69 6-6 6-6-2.69-6-6H4c0 4.42 3.58 8 8 8s8-3.58 8-8-3.58-8-8-8z",
  __self: void 0,
  __source: {
    fileName: _jsxFileName,
    lineNumber: 20,
    columnNumber: 9
  }
}));

var PlayButton = /*#__PURE__*/function (_Component) {
  _inheritsLoose(PlayButton, _Component);

  function PlayButton() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      _this.props.dispatch({
        type: 'USER_ACTIVE'
      });

      if (!_this.props.isReadingTerminated) {
        if (_this.props.isPlaying) {
          _this.props.dispatch({
            type: 'PREVENT_MENU_HIDING'
          });

          _this.props.dispatch({
            type: 'PAUSE'
          });
        } else {
          _this.props.dispatch({
            type: 'PLAY'
          });

          _this.props.dispatch({
            type: 'ALLOW_MENU_HIDING'
          });
        }
      } else {
        _this.props.dispatch({
          type: 'UPDATE_ASKED_TIME',
          payload: {
            askedTime: 0
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "render", function () {
      var action;

      if (!_this.props.isReadingTerminated) {
        if (_this.props.isPlaying) {
          action = pauseLogo;
        } else {
          action = playLogo;
        }
      } else {
        action = replayLogo;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "wmp-tool-button",
        onClick: _this.handleClick,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 52,
          columnNumber: 13
        }
      }, action);
    });

    return _this;
  }

  return PlayButton;
}(_react.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    isPlaying: state.isPlaying,
    isReadingTerminated: state.isReadingTerminated
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps)(PlayButton);

exports["default"] = _default;
module.exports = exports.default;