"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _HighlightPlayer = _interopRequireDefault(require("../actions/HighlightPlayer"));

var _UnhighlightPlayer = _interopRequireDefault(require("../actions/UnhighlightPlayer"));

var _InitializePlayer = _interopRequireDefault(require("../actions/InitializePlayer"));

var _ShowVolumeSlider = _interopRequireDefault(require("../actions/ShowVolumeSlider"));

var _HideVolumeSlider = _interopRequireDefault(require("../actions/HideVolumeSlider"));

var _SwitchFullscreen = _interopRequireDefault(require("../actions/SwitchFullscreen"));

var _AdaptPlayerToFullscreen = _interopRequireDefault(require("../actions/AdaptPlayerToFullscreen"));

var _AdaptPlayerToNonFullscreen = _interopRequireDefault(require("../actions/AdaptPlayerToNonFullscreen"));

var _UpdateVolume = _interopRequireDefault(require("../actions/UpdateVolume"));

var _SaveActualVolumeAsPastVolume = _interopRequireDefault(require("../actions/SaveActualVolumeAsPastVolume"));

var _UpdateVolumeSliderLeftMargin = _interopRequireDefault(require("../actions/UpdateVolumeSliderLeftMargin"));

var _PreventMouseLeaveVolumeSlider = _interopRequireDefault(require("../actions/PreventMouseLeaveVolumeSlider"));

var _AllowMouseLeaveVolumeSlider = _interopRequireDefault(require("../actions/AllowMouseLeaveVolumeSlider"));

var _HighlightProgressBar = _interopRequireDefault(require("../actions/HighlightProgressBar"));

var _UnhighlightProgressBar = _interopRequireDefault(require("../actions/UnhighlightProgressBar"));

var _ReadingNotTerminated = _interopRequireDefault(require("../actions/ReadingNotTerminated"));

var _ReadingTerminated = _interopRequireDefault(require("../actions/ReadingTerminated"));

var _UpdateCurrentTime = _interopRequireDefault(require("../actions/UpdateCurrentTime"));

var _PreventUnhighlightProgressBar = _interopRequireDefault(require("../actions/PreventUnhighlightProgressBar"));

var _AllowUnhighlightProgressBar = _interopRequireDefault(require("../actions/AllowUnhighlightProgressBar"));

var _Play = _interopRequireDefault(require("../actions/Play"));

var _Pause = _interopRequireDefault(require("../actions/Pause"));

var _ShowMenus = _interopRequireDefault(require("../actions/ShowMenus"));

var _HideMenus = _interopRequireDefault(require("../actions/HideMenus"));

var _UpdateTimeLastUserAction = _interopRequireDefault(require("../actions/UpdateTimeLastUserAction"));

var _ShowCursor = _interopRequireDefault(require("../actions/ShowCursor"));

var _HideCursor = _interopRequireDefault(require("../actions/HideCursor"));

var _UpdateDuration = _interopRequireDefault(require("../actions/UpdateDuration"));

var _AudioNotReady = _interopRequireDefault(require("../actions/AudioNotReady"));

var _AudioReady = _interopRequireDefault(require("../actions/AudioReady"));

var _VideoNotReady = _interopRequireDefault(require("../actions/VideoNotReady"));

var _VideoReady = _interopRequireDefault(require("../actions/VideoReady"));

var _SlideshowNotReady = _interopRequireDefault(require("../actions/SlideshowNotReady"));

var _SlideshowReady = _interopRequireDefault(require("../actions/SlideshowReady"));

var _AddImage = _interopRequireDefault(require("../actions/AddImage"));

var _Loading = _interopRequireDefault(require("../actions/Loading"));

var _NotLoading = _interopRequireDefault(require("../actions/NotLoading"));

var _UpdateAskedTime = _interopRequireDefault(require("../actions/UpdateAskedTime"));

var _UpdateImageDisplayed = _interopRequireDefault(require("../actions/UpdateImageDisplayed"));

var _AskPreviousImage = _interopRequireDefault(require("../actions/AskPreviousImage"));

var _AskNextImage = _interopRequireDefault(require("../actions/AskNextImage"));

var _UpdateVideoWidth = _interopRequireDefault(require("../actions/UpdateVideoWidth"));

var _UpdateVideoHeight = _interopRequireDefault(require("../actions/UpdateVideoHeight"));

var _PreventMenuHiding = _interopRequireDefault(require("../actions/PreventMenuHiding"));

var _AllowMenuHiding = _interopRequireDefault(require("../actions/AllowMenuHiding"));

var _UpdateTimeRangeBuffered = _interopRequireDefault(require("../actions/UpdateTimeRangeBuffered"));

var _ChannelsWait = _interopRequireDefault(require("../actions/ChannelsWait"));

var _ChannelsContinue = _interopRequireDefault(require("../actions/ChannelsContinue"));

var _VinylReady = _interopRequireDefault(require("../actions/VinylReady"));

var _Mute = _interopRequireDefault(require("../actions/Mute"));

var _Unmute = _interopRequireDefault(require("../actions/Unmute"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var reducer = function reducer(state, action) {
  if (state === undefined) {
    return null;
  }

  if (action === undefined) {
    return state;
  }

  switch (action.type) {
    case "UNMUTE":
      return (0, _Unmute["default"])(state);

    case "MUTE":
      return (0, _Mute["default"])(state);

    case "VINYL_IS_READY":
      return (0, _VinylReady["default"])(state);

    case "CHANNELS_CONTINUE":
      return (0, _ChannelsContinue["default"])(state);

    case "CHANNELS_WAIT":
      return (0, _ChannelsWait["default"])(state);

    case "UPDATE_TIME_RANGE_BUFFERED":
      return (0, _UpdateTimeRangeBuffered["default"])(state, action);

    case "PREVENT_MENU_HIDING":
      return (0, _PreventMenuHiding["default"])(state);

    case "ALLOW_MENU_HIDING":
      return (0, _AllowMenuHiding["default"])(state);

    case "UPDATE_VIDEO_WIDTH":
      return (0, _UpdateVideoWidth["default"])(state, action);

    case "UPDATE_VIDEO_HEIGHT":
      return (0, _UpdateVideoHeight["default"])(state, action);

    case "ASK_NEXT_IMAGE":
      return (0, _AskNextImage["default"])(state);

    case "ASK_PREVIOUS_IMAGE":
      return (0, _AskPreviousImage["default"])(state);

    case 'UPDATE_IMAGE_DISPLAYED':
      return (0, _UpdateImageDisplayed["default"])(state, action);

    case 'UPDATE_ASKED_TIME':
      return (0, _UpdateAskedTime["default"])(state, action);

    case 'NOT_LOADING':
      return (0, _NotLoading["default"])(state, action);

    case 'LOADING':
      return (0, _Loading["default"])(state, action);

    case 'ADD_IMAGE':
      return (0, _AddImage["default"])(state, action);

    case 'AUDIO_IS_NOT_READY':
      return (0, _AudioNotReady["default"])(state);

    case 'AUDIO_IS_READY':
      return (0, _AudioReady["default"])(state);

    case 'VIDEO_IS_NOT_READY':
      return (0, _VideoNotReady["default"])(state);

    case 'VIDEO_IS_READY':
      return (0, _VideoReady["default"])(state);

    case 'SLIDESHOW_IS_NOT_READY':
      return (0, _SlideshowNotReady["default"])(state);

    case 'SLIDESHOW_IS_READY':
      return (0, _SlideshowReady["default"])(state);

    case 'UPDATE_DURATION':
      return (0, _UpdateDuration["default"])(state, action);

    case 'SHOW_CURSOR':
      return (0, _ShowCursor["default"])(state);

    case 'HIDE_CURSOR':
      return (0, _HideCursor["default"])(state);

    case 'UPDATE_CURRENT_TIME':
      return (0, _UpdateCurrentTime["default"])(state, action);

    case 'SHOW_MENUS':
      return (0, _ShowMenus["default"])(state);

    case 'HIDE_MENUS':
      return (0, _HideMenus["default"])(state);

    case 'USER_ACTIVE':
      return (0, _UpdateTimeLastUserAction["default"])(state);

    case 'PLAY':
      return (0, _Play["default"])(state);

    case 'PAUSE':
      return (0, _Pause["default"])(state);

    case 'ALLOW_UNHIGHLIGHT_PROGRESS_BAR':
      return (0, _AllowUnhighlightProgressBar["default"])(state);

    case 'PREVENT_UNHIGHLIGHT_PROGRESS_BAR':
      return (0, _PreventUnhighlightProgressBar["default"])(state);

    case 'READING_TERMINATED':
      return (0, _ReadingTerminated["default"])(state);

    case 'READING_NOT_TERMINATED':
      return (0, _ReadingNotTerminated["default"])(state);

    case 'HIGHLIGHT_PROGRESS_BAR':
      return (0, _HighlightProgressBar["default"])(state);

    case 'UNHIGHLIGHT_PROGRESS_BAR':
      return (0, _UnhighlightProgressBar["default"])(state);

    case 'ALLOW_MOUSE_LEAVE_VOLUME_SLIDER':
      return (0, _AllowMouseLeaveVolumeSlider["default"])(state);

    case 'PREVENT_MOUSE_LEAVE_VOLUME_SLIDER':
      return (0, _PreventMouseLeaveVolumeSlider["default"])(state);

    case 'UPDATE_VOLUME_SLIDER_LEFT_MARGIN':
      return (0, _UpdateVolumeSliderLeftMargin["default"])(state, action);

    case 'SAVE_ACTUAL_VOLUME_AS_PAST_VOLUME':
      return (0, _SaveActualVolumeAsPastVolume["default"])(state);

    case 'UPDATE_VOLUME':
      return (0, _UpdateVolume["default"])(state, action);

    case 'FULL_SCREEN_ENABLED':
      return (0, _AdaptPlayerToFullscreen["default"])(state);

    case 'FULL_SCREEN_DISABLED':
      return (0, _AdaptPlayerToNonFullscreen["default"])(state);

    case 'SWITCH_FULLSCREEN_STATE':
      return (0, _SwitchFullscreen["default"])(state);

    case 'SHOW_VOLUME_SLIDER':
      return (0, _ShowVolumeSlider["default"])(state);

    case 'HIDE_VOLUME_SLIDER':
      return (0, _HideVolumeSlider["default"])(state);

    case 'HIGHLIGHT_PLAYER':
      return (0, _HighlightPlayer["default"])(state);

    case 'UNHIGHLIGHT_PLAYER':
      return (0, _UnhighlightPlayer["default"])(state);

    case 'INITIALIZE_PLAYER':
      return (0, _InitializePlayer["default"])(state);

    case 'INIT_STATE':
      return action.payload.state;

    default:
      return state;
  }
};

var _default = reducer;
exports["default"] = _default;
module.exports = exports.default;